<?php

namespace Teknisa\CADFIS\Factories;

use Doctrine\ORM\EntityManager;

class Dfs47000ValorMaximoVendaConsumidorFactory {
    
    public function __construct(EntityManager $entityManager) {
        $this->entityManager    = $entityManager;
        $this->connection       = $entityManager->getConnection();
    }
    
    public function selectVRMAXVENPROD($produto, $pais, $estado, $nrorg){
        try {
            $sql = "SELECT * FROM VRMAXVENPROD 
                        WHERE (CDPRODUTO = :CDPRODUTO)
                        AND (CDPAIS = :CDPAIS)
                        AND (SGESTADO = :SGESTADO)
                        AND (NRORG = :NRORG)";

            $params = array(
                'CDPRODUTO'=>$produto,
                'CDPAIS'=>$pais,
                'SGESTADO'=>$estado,
                'NRORG'=>$nrorg
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
    } 
    
    public function insertVRMAXVENPROD($IDUTILVRMAX, $VRDESCMAXVENDA, $VRMAXVENDA, $VRPEMAXVENDA, $CDPRODUTO, $CDPAIS, $SGESTADO, $IDVDVALOPER, $VRPMPF, $NRORG){
        try {
            $sql = "INSERT INTO VRMAXVENPROD 
                               (IDUTILVRMAX, VRDESCMAXVENDA, VRMAXVENDA, VRPEMAXVENDA, CDPRODUTO, CDPAIS, SGESTADO, IDVDVALOPER, VRPMPF, NRORG)
                                    VALUES ( :IDUTILVRMAX, 
                                            :VRDESCMAXVENDA, 
                                            :VRMAXVENDA, 
                                            :VRPEMAXVENDA, 
                                            :CDPRODUTO, 
                                            :CDPAIS, 
                                            :SGESTADO,
                                            :IDVDVALOPER,
                                            :VRPMPF,
                                            :NRORG)";
                     
            $params = array(
                'IDUTILVRMAX'=>$IDUTILVRMAX,
                'VRDESCMAXVENDA'=>$VRDESCMAXVENDA,
                'VRMAXVENDA'=>$VRMAXVENDA,
                'VRPEMAXVENDA'=>$VRPEMAXVENDA,
                'CDPRODUTO'=>$CDPRODUTO,
                'CDPAIS'=>$CDPAIS,
                'SGESTADO'=>$SGESTADO,
                'IDVDVALOPER'=>$IDVDVALOPER,
                'VRPMPF'=>$VRPMPF,
                'NRORG'=>$NRORG
            );
            $std = $this->connection->prepare($sql);
            $result = $std->execute($params);
            return $result;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function updateVRMAXVENPROD($IDUTILVRMAX, $VRDESCMAXVENDA, $VRMAXVENDA, $VRPEMAXVENDA, $CDPRODUTO, $CDPAIS, $SGESTADO, $IDVDVALOPER, $VRPMPF, $NRORG){
        try {
            $sql = "UPDATE VRMAXVENPROD
                          SET IDUTILVRMAX = :IDUTILVRMAX,
                            VRDESCMAXVENDA = :VRDESCMAXVENDA,
                            VRMAXVENDA = :VRMAXVENDA,
                            VRPEMAXVENDA = :VRPEMAXVENDA,
                            IDVDVALOPER = :IDVDVALOPER,
                            VRPMPF = :VRPMPF

                        WHERE (CDPRODUTO = :CDPRODUTO)
                            AND (CDPAIS = :CDPAIS)
                            AND (SGESTADO = :SGESTADO)
                            AND (NRORG = :NRORG) ";
                            
            $params = array(
                'IDUTILVRMAX'=>$IDUTILVRMAX,
                'VRDESCMAXVENDA'=>$VRDESCMAXVENDA,
                'VRMAXVENDA'=>$VRMAXVENDA,
                'VRPEMAXVENDA'=>$VRPEMAXVENDA,
                'CDPRODUTO'=>$CDPRODUTO,
                'CDPAIS'=>$CDPAIS,
                'SGESTADO'=>$SGESTADO,
                'IDVDVALOPER'=>$IDVDVALOPER,
                'VRPMPF'=>$VRPMPF,
                'NRORG'=>$NRORG
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function selectVRMAXVENPROD_PROD($pais, $estado, $nrorg){
        try {
            $sql = "SELECT IDUTILVRMAX,
                            VRDESCMAXVENDA,
                            VRMAXVENDA,
                            VRPEMAXVENDA,
                            CDPRODUTO,
                            NRORG
                            FROM VRMAXVENPROD 
                                WHERE (CDPAIS = :CDPAIS)
                                AND (SGESTADO = :SGESTADO)
                                AND (NRORG = :NRORG)";

            $params = array(
                'CDPAIS'=>$pais,
                'SGESTADO'=>$estado,
                'NRORG'=>$nrorg
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function selectProdCadastAutom($row){
        try {
            $sql = "SELECT CDPRODUTO,
                          NMPRODUTO,
                          CDARVPROD
                            FROM PRODUTO 
                                  WHERE (CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIN)
                                  AND (CDNVPRODUTO =
                                  (SELECT MAX(CDNVPRODUTO) FROM PRODUTO
                                  ))";

            $params = array(
                'CDPRODINI'=>$row['CDARVPRODINI'],
                'CDPRODFIN'=>$row['CDARVPRODFIN']
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
    } 
    
    
}