<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;


class PtoOcorrenciaadmissao extends \Doctrine\ORM\EntityRepository {
    
    public function getOcorrenciasNaAdmissao($nrorg, $nrtipovinculom, $nrestrutlegal, $nrestrutgeren, $nrestrutsind, $nrocupacaom, $nrescalatrabm = null) {
        $ocorrenciasAdmissaoComFiltrosEspecificos = $this->getOcorrenciasFiltrosEspecificos(
            $nrorg, $nrtipovinculom, $nrestrutlegal, $nrestrutgeren, $nrestrutsind, $nrocupacaom, $nrescalatrabm
        );
        
        /* Verifica se existem ocorrencias com filtros especificos preenchidos */
        
        $existemOcorrenciasEspecificas = count($ocorrenciasAdmissaoComFiltrosEspecificos) > 0;
        if ($existemOcorrenciasEspecificas) {
            return $ocorrenciasAdmissaoComFiltrosEspecificos;
        }
        
        /* Retorna ocorrencias sem filtros preenchidos se nao houverem registros com filtros especificos (defaults) */
        
        return $this->getOcorrenciasSemFiltrosEspecificos($nrorg, $nrtipovinculom);
    }
    
    public function getOcorrenciasFiltrosEspecificos($nrorg, $nrtipovinculom, $nrestrutlegal, $nrestrutgeren, $nrestrutsind, $nrocupacaom, $nrescalatrabm = null) {
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
        
        $params = array(
            'P_NRORG'           => $nrorg, 
            'P_NRTIPOVINCULOM'  => $nrtipovinculom,
            'P_NRESTRUTLEGAL'   => $nrestrutlegal,
            'P_NRESTRUTGEREN'   => $nrestrutgeren,
            'P_NRESTRUTSIND'    => $nrestrutsind,
            'P_NROCUPACAOM'     => $nrocupacaom,
            'P_NRESCALATRABM'   => $nrescalatrabm
        );

$sql = <<<SQL
    SELECT OCA.*
FROM PTO_OCORRENCIADMISSAO OCA
WHERE OCA.NRORG = :P_NRORG
    AND OCA.NRTIPOVINCULOM = :P_NRTIPOVINCULOM
    AND ( INSTR( ',' || OCA.NRESTRUTLEGAL    || ',', ','    || :P_NRESTRUTLEGAL    ||  ','  ) > 0 OR OCA.NRESTRUTLEGAL IS NULL )
    AND ( INSTR( ',' || OCA.NRESTRUTGEREN    || ',', ','    || :P_NRESTRUTGEREN    ||  ','  ) > 0 OR OCA.NRESTRUTGEREN IS NULL )
    AND ( INSTR( ',' || OCA.NRESTRUTSIND     || ',', ','    || :P_NRESTRUTSIND     ||  ','  ) > 0 OR OCA.NRESTRUTSIND  IS NULL )
    AND ( INSTR( ',' || OCA.NROCUPACAOM      || ',', ','    || :P_NROCUPACAOM      ||  ','  ) > 0 OR OCA.NROCUPACAOM   IS NULL )
    AND ( INSTR( ',' || OCA.NRESCALATRABM      || ',', ','    || :P_NRESCALATRABM      ||  ','  ) > 0 OR OCA.NRESCALATRABM   IS NULL )
    AND ( OCA.NRESTRUTLEGAL IS NOT NULL OR OCA.NRESTRUTGEREN IS NOT NULL OR OCA.NRESTRUTSIND IS NOT NULL OR OCA.NROCUPACAOM IS NOT NULL OR OCA.NRESCALATRABM IS NOT NULL)
    AND OCA.IDATIVO = 'S'
SQL;

        $result = $db->fetchAll($sql,$params);

        return $result;
    }
    
    public function getOcorrenciasSemFiltrosEspecificos($nrorg, $nrtipovinculom){
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
        
        $params = array(
            'P_NRORG'           => $nrorg, 
            'P_NRTIPOVINCULOM'  => $nrtipovinculom
        );

$sql = <<<SQL
    SELECT OCA.*
FROM PTO_OCORRENCIADMISSAO OCA
WHERE OCA.NRORG = :P_NRORG
    AND OCA.NRTIPOVINCULOM = :P_NRTIPOVINCULOM
    AND OCA.NRESTRUTLEGAL IS NULL
    AND OCA.NRESTRUTGEREN IS NULL
    AND OCA.NRESTRUTSIND IS NULL
    AND OCA.NROCUPACAOM IS NULL
    AND OCA.IDATIVO = 'S'
SQL;

        $result = $db->fetchAll($sql,$params);

        return $result;
    }

    
}